Index: trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 2528)
@@ -15,6 +15,6 @@
    USE oce_trc         ! Ocean variables
    USE trc             ! TOP variables
-   USE trdmld_trc_oce
-   USE trdmld_trc
+   USE trdmod_oce
+   USE trdmod_trc
 
    IMPLICIT NONE
@@ -24,7 +24,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -64,5 +64,5 @@
           DO jn = jp_myt0, jp_myt1
             ztrmyt(:,:,:) = tra(:,:,:,jn)
-            CALL trd_mod_trc( ztrmyt, jn, jptrc_trd_sms, kt )   ! save trends
+            CALL trd_mod_trc( ztrmyt, jn, jptra_trd_sms, kt )   ! save trends
           END DO
       END IF
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2528)
@@ -41,7 +41,7 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -84,11 +84,11 @@
       CALL p4z_sink ( kt, jnt )     ! vertical flux of particulate organic matter
       CALL p4z_opt  ( kt, jnt )     ! Optic: PAR in the water column
-      CALL p4z_lim  ( kt, jnt )     ! co-limitations by the various nutrients
+      CALL p4z_lim  ( kt      )     ! co-limitations by the various nutrients
       CALL p4z_prod ( kt, jnt )     ! phytoplankton growth rate over the global ocean. 
       !                             ! (for each element : C, Si, Fe, Chl )
-      CALL p4z_rem  ( kt, jnt )     ! remineralization terms of organic matter+scavenging of Fe
-      CALL p4z_mort ( kt, jnt )     ! phytoplankton mortality
+      CALL p4z_rem  ( kt      )     ! remineralization terms of organic matter+scavenging of Fe
+      CALL p4z_mort ( kt      )     ! phytoplankton mortality
       !                             ! zooplankton sources/sinks routines 
-      CALL p4z_micro( kt, jnt )           ! microzooplankton
+      CALL p4z_micro( kt      )           ! microzooplankton
       CALL p4z_meso ( kt, jnt )           ! mesozooplankton
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2528)
@@ -149,7 +149,7 @@
 #include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -181,8 +181,8 @@
 
             !                             ! SET ABSOLUTE TEMPERATURE
-            ztkel = tn(ji,jj,1) + 273.16
+            ztkel = tsn(ji,jj,1,jp_tem) + 273.16
             zqtt  = ztkel * 0.01
             zqtt2 = zqtt * zqtt
-            zsal  = sn(ji,jj,1) + (1.- tmask(ji,jj,1) ) * 35.
+            zsal  = tsn(ji,jj,1,jp_sal) + (1.- tmask(ji,jj,1) ) * 35.
             zlqtt = LOG( zqtt )
 
@@ -214,7 +214,7 @@
 
                ! SET ABSOLUTE TEMPERATURE
-               ztkel   = tn(ji,jj,jk) + 273.16
+               ztkel   = tsn(ji,jj,jk,jp_tem) + 273.16
                zqtt    = ztkel * 0.01
-               zsal    = sn(ji,jj,jk) + ( 1.-tmask(ji,jj,jk) ) * 35.
+               zsal    = tsn(ji,jj,jk,jp_sal) + ( 1.-tmask(ji,jj,jk) ) * 35.
                zsqrt  = SQRT( zsal )
                zsal15  = zsqrt * zsal
@@ -224,5 +224,5 @@
                zis2   = zis * zis
                zisqrt = SQRT( zis )
-               ztc     = tn(ji,jj,jk) + ( 1.- tmask(ji,jj,jk) ) * 20.
+               ztc     = tsn(ji,jj,jk,jp_tem) + ( 1.- tmask(ji,jj,jk) ) * 20.
 
                ! CHLORINITY (WOOSTER ET AL., 1969)
@@ -249,6 +249,6 @@
                   &    + ( cb8 + cb9 * zsqrt + cb10 * zsal ) * zlogt + cb11 * zsqrt * ztkel             &
                   &    + LOG(  ( 1.+ zst / zcks + zft / zckf ) / ( 1.+ zst / zcks )  )
-!!gm zsal**2 to be replaced by a *...
-               zck1    = c10 * ztr + c11 + c12 * zlogt + c13 * zsal + c14 * zsal**2
+
+               zck1    = c10 * ztr + c11 + c12 * zlogt + c13 * zsal + c14 * zsal * zsal
                zck2    = c20 * ztr + c21 + c22 * zsal   + c23 * zsal**2
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2528)
@@ -28,4 +28,5 @@
 #endif
    USE lib_mpp
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -33,28 +34,21 @@
 
    PUBLIC   p4z_flx  
-
-   REAL(wp) :: &  ! pre-industrial atmospheric [co2] (ppm) 	
-      atcox  = 0.20946 ,    &  !:
-      atcco2 = 278.            !:
-
-   REAL(wp) :: &
-      xconv  = 0.01/3600      !: coefficients for conversion 
-
-   INTEGER  ::  nspyr         !: number of timestep per year
-
-#if defined key_cpl_carbon_cycle
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  &
-      oce_co2            !: ocean carbon flux
-   REAL(wp) :: &
-      t_atm_co2_flx,  &  !: Total atmospheric carbon flux per year
-      t_oce_co2_flx      !: Total ocean carbon flux per year
-#endif
+   PUBLIC   p4z_flx_init  
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  oce_co2            !: ocean carbon flux 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  satmco2            !: atmospheric pco2
+   REAL(wp)                             ::  t_oce_co2_flx      !: Total ocean carbon flux 
+   REAL(wp)                             ::  t_atm_co2_flx      !: global mean of atmospheric pco2
+   REAL(wp)                             ::  area               !: ocean surface
+   REAL(wp)                             ::  atcco2 = 278.      !: pre-industrial atmospheric [co2] (ppm) 	
+   REAL(wp)                             ::  atcox  = 0.20946   !:
+   REAL(wp)                             ::  xconv  = 0.01/3600 !: coefficients for conversion 
 
    !!* Substitution
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -75,17 +69,18 @@
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zsch_o2, zalka, zsch_co2
       REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3
-#if defined key_trc_diaadd && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj) ::  zcflx, zoflx, zkg, zdpco2, zdpo2
+#if defined key_diatrc && defined key_iomput
+      REAL(wp), DIMENSION(jpi,jpj) ::  zoflx, zkg, zdpco2, zdpo2
 #endif
       CHARACTER (len=25) :: charout
 
       !!---------------------------------------------------------------------
-
-
-      IF( kt == nittrc000  )   CALL p4z_flx_init      ! Initialization (first time-step only)
 
       ! SURFACE CHEMISTRY (PCO2 AND [H+] IN
       !     SURFACE LAYER); THE RESULT OF THIS CALCULATION
       !     IS USED TO COMPUTE AIR-SEA FLUX OF CO2
+
+#if defined key_cpl_carbon_cycle
+      satmco2(:,:) = atm_co2(:,:)
+#endif
 
       DO jrorr = 1, 10
@@ -128,5 +123,5 @@
 !CDIR NOVERRCHK
          DO ji = 1, jpi
-            ztc  = MIN( 35., tn(ji,jj,1) )
+            ztc  = MIN( 35., tsn(ji,jj,1,jp_tem) )
             ztc2 = ztc * ztc
             ztc3 = ztc * ztc2 
@@ -138,5 +133,5 @@
             ! Compute the piston velocity for O2 and CO2
             zkgwan = 0.3 * zws  + 2.5 * ( 0.5246 + 0.016256 * ztc + 0.00049946  * ztc2 )
-# if defined key_off_degrad
+# if defined key_degrad
             zkgwan = zkgwan * xconv * ( 1.- fr_i(ji,jj) ) * tmask(ji,jj,1) * facvol(ji,jj,1)
 #else
@@ -152,14 +147,9 @@
          DO ji = 1, jpi
             ! Compute CO2 flux for the sea and air
-#if ! defined key_cpl_carbon_cycle
-            zfld = atcco2 * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
+            zfld = satmco2(ji,jj) * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
             zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)
-#else
-            zfld = atm_co2(ji,jj) * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
-            zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)
-            ! compute flux of carbon
             oce_co2(ji,jj) = ( zfld - zflu ) * rfact &
                &             * e1t(ji,jj) * e2t(ji,jj) * tmask(ji,jj,1) * 1000.
-#endif
+            ! compute the trend
             tra(ji,jj,1,jpdic) = tra(ji,jj,1,jpdic) + ( zfld - zflu ) / fse3t(ji,jj,1)
 
@@ -169,20 +159,18 @@
             tra(ji,jj,1,jpoxy) = tra(ji,jj,1,jpoxy) + ( zfld16 - zflu16 ) / fse3t(ji,jj,1)
 
-#if defined key_trc_diaadd 
+#if defined key_diatrc 
             ! Save diagnostics
 #  if ! defined key_iomput
-            trc2d(ji,jj,jp_pcs0_2d    ) = ( zfld - zflu )     * 1000. * tmask(ji,jj,1)
+            zfact = 1. / ( e1t(ji,jj) * e2t(ji,jj) ) / rfact
+            trc2d(ji,jj,jp_pcs0_2d    ) = oce_co2(ji,jj) * zfact
             trc2d(ji,jj,jp_pcs0_2d + 1) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
             trc2d(ji,jj,jp_pcs0_2d + 2) = zkgco2(ji,jj) * tmask(ji,jj,1)
-            trc2d(ji,jj,jp_pcs0_2d + 3) = ( atcco2 - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) &
+            trc2d(ji,jj,jp_pcs0_2d + 3) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) &
                &                            * tmask(ji,jj,1)
 #  else
-            zcflx(ji,jj) = ( zfld - zflu ) * 1000.  * tmask(ji,jj,1)
             zoflx(ji,jj) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
             zkg  (ji,jj) = zkgco2(ji,jj) * tmask(ji,jj,1)
-            zdpco2(ji,jj) = ( atcco2 - zh2co3(ji,jj)      / ( chemc(ji,jj,1) + rtrn ) ) &
-              &             * tmask(ji,jj,1)
-            zdpo2 (ji,jj) = ( atcox  - trn(ji,jj,1,jpoxy) / ( chemc(ji,jj,2) + rtrn ) ) &
-              &             * tmask(ji,jj,1)
+            zdpco2(ji,jj) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) * tmask(ji,jj,1)
+            zdpo2 (ji,jj) = ( atcox  - trn(ji,jj,1,jpoxy) / ( chemc(ji,jj,2) + rtrn ) ) * tmask(ji,jj,1)
 #  endif
 #endif
@@ -190,35 +178,21 @@
       END DO
 
-#if defined key_cpl_carbon_cycle
-      ! Total Flux of Carbon
-      DO jj = 1, jpj 
-        DO ji = 1, jpi
-           t_atm_co2_flx = t_atm_co2_flx + atm_co2(ji,jj) * tmask_i(ji,jj)
-           t_oce_co2_flx = t_oce_co2_flx + oce_co2(ji,jj) * tmask_i(ji,jj)
-        END DO
-      END DO
-
-      IF( MOD( kt, nspyr ) == 0 ) THEN
-        IF( lk_mpp ) THEN
-          CALL mpp_sum( t_atm_co2_flx )   ! sum over the global domain
-          CALL mpp_sum( t_oce_co2_flx )   ! sum over the global domain
-        ENDIF
-        ! Conversion in GtC/yr ; negative for outgoing from ocean
-        t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15
-        !
-        WRITE(numout,*) ' Atmospheric pCO2    :'
-        WRITE(numout,*) '-------------------- : ',kt,'  ',t_atm_co2_flx
-        WRITE(numout,*) '(ppm)'
-        WRITE(numout,*) 'Total Flux of Carbon out of the ocean :'
-        WRITE(numout,*) '-------------------- : ',t_oce_co2_flx
-        WRITE(numout,*) '(GtC/yr)'
-        t_atm_co2_flx = 0.
-        t_oce_co2_flx = 0.
-# if defined key_iomput
-        CALL iom_put( "tatpco2" , t_atm_co2_flx  )
-        CALL iom_put( "tco2flx" , t_oce_co2_flx  )
-#endif
+      t_oce_co2_flx = t_oce_co2_flx + glob_sum( oce_co2(:,:) )                     ! Cumulative Total Flux of Carbon
+      IF( kt == nitend ) THEN
+         t_atm_co2_flx = glob_sum( satmco2(:,:) * e1t(:,:) * e2t(:,:) )            ! Total atmospheric pCO2
+         !
+         t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15                      ! Conversion in PgC ; negative for out of the ocean
+         t_atm_co2_flx = t_atm_co2_flx  / area                                     ! global mean of atmospheric pCO2
+         !
+         IF( lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' Global mean of atmospheric pCO2 (ppm) at it= ', kt, ' date= ', ndastp
+            WRITE(numout,*) '------------------------------------------------------- :  ',t_atm_co2_flx
+            WRITE(numout,*)
+            WRITE(numout,*) ' Cumulative total Flux of Carbon out of the ocean (PgC) :'
+            WRITE(numout,*) '-------------------------------------------------------  ',t_oce_co2_flx
+         ENDIF
+         !
       ENDIF
-#endif
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -228,6 +202,6 @@
       ENDIF
 
-# if defined key_trc_diaadd && defined key_iomput
-      CALL iom_put( "Cflx" , zcflx  )
+# if defined key_diatrc && defined key_iomput
+      CALL iom_put( "Cflx" , oce_co2(:,:) / ( e1t(:,:) * e2t(:,:) ) / rfact  )
       CALL iom_put( "Oflx" , zoflx  )
       CALL iom_put( "Kg"   , zkg    )
@@ -246,5 +220,5 @@
       !!
       !! ** Method  :   Read the nampisext namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep (nit000)
       !! ** input   :   Namelist nampisext
       !!
@@ -263,13 +237,13 @@
       ENDIF
 
-      ! number of time step per year  
-      nspyr = INT( nyear_len(1) * rday / rdt )
-
-#if defined key_cpl_carbon_cycle
+      ! interior global domain surface
+      area = glob_sum( e1t(:,:) * e2t(:,:) )  
+
       ! Initialization of Flux of Carbon
-      oce_co2(:,:) = 0.
-      t_atm_co2_flx = 0.
-      t_oce_co2_flx = 0.
-#endif
+      oce_co2(:,:)  = 0._wp
+      t_atm_co2_flx = 0._wp
+      ! Initialisation of atmospheric pco2
+      satmco2(:,:)  = atcco2
+      t_oce_co2_flx = 0._wp
 
    END SUBROUTINE p4z_flx_init
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2528)
@@ -32,7 +32,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -55,6 +55,6 @@
       ! -------------------------------------------
 
-      tgfunc (:,:,:) = EXP( 0.063913 * tn(:,:,:) )
-      tgfunc2(:,:,:) = EXP( 0.07608  * tn(:,:,:) )
+      tgfunc (:,:,:) = EXP( 0.063913 * tsn(:,:,:,jp_tem) )
+      tgfunc2(:,:,:) = EXP( 0.07608  * tsn(:,:,:,jp_tem) )
 
       ! Computation of the silicon dependant half saturation
@@ -69,5 +69,5 @@
       END DO
 
-      IF( nday_year == 365 ) THEN
+      IF( nday_year == nyear_len(1) ) THEN
          xksi    = xksimax
          xksimax = 0.e0
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2528)
@@ -23,4 +23,5 @@
 
    PUBLIC p4z_lim    
+   PUBLIC p4z_lim_init    
 
    !! * Shared module variables
@@ -43,12 +44,12 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE p4z_lim( kt, jnt )
+   SUBROUTINE p4z_lim( kt )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE p4z_lim  ***
@@ -59,5 +60,5 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
+      INTEGER, INTENT(in)  :: kt
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zlim1, zlim2, zlim3, zlim4, zno3, zferlim
@@ -67,10 +68,7 @@
 
 
-      IF( ( kt * jnt ) == nittrc000  )   CALL p4z_lim_init      ! Initialization (first time-step only)
-
-
-!  Tuning of the iron concentration to a minimum
-!  level that is set to the detection limit
-!  -------------------------------------
+      !  Tuning of the iron concentration to a minimum
+      !  level that is set to the detection limit
+      !  -------------------------------------
 
       DO jk = 1, jpkm1
@@ -85,8 +83,7 @@
       END DO
 
-!  Computation of a variable Ks for iron on diatoms
-!  taking into account that increasing biomass is
-!  made of generally bigger cells
-!  ------------------------------------------------
+      !  Computation of a variable Ks for iron on diatoms taking into account
+      !  that increasing biomass is made of generally bigger cells
+      !  ------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -107,11 +104,9 @@
       END DO
 
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-    
-!      Michaelis-Menten Limitation term for nutrients
-!      Small flagellates
-!      -----------------------------------------------
+     !  Michaelis-Menten Limitation term for nutrients Small flagellates
+     !      -----------------------------------------------
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
               zdenom = 1. / &
                   & ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3) + conc0 * trn(ji,jj,jk,jpnh4) )
@@ -132,10 +127,9 @@
       END DO
 
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
-!   Michaelis-Menten Limitation term for nutrients Diatoms
-!   ----------------------------------------------
+      !   Michaelis-Menten Limitation term for nutrients Diatoms
+      !   ----------------------------------------------
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
               zdenom = 1. / &
                   & ( conc1 * concdnh4 + concdnh4 * trn(ji,jj,jk,jpno3) + conc1 * trn(ji,jj,jk,jpnh4) )
@@ -161,5 +155,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               ztemp = MAX( 0., tn(ji,jj,jk) )
+               ztemp = MAX( 0., tsn(ji,jj,jk,jp_tem) )
                xfracal(ji,jj,jk) = caco3r * xlimphy(ji,jj,jk)   &
                   &                       * MAX( 0.0001, ztemp / ( 2.+ ztemp ) )   &
@@ -181,5 +175,5 @@
       !!
       !! ** Method  :   Read the nampislim namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep (nit000)
       !!
       !! ** input   :   Namelist nampislim
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2528)
@@ -27,5 +27,6 @@
    PRIVATE
 
-   PUBLIC   p4z_lys    ! called in p4zprg.F90
+   PUBLIC   p4z_lys         ! called in trcsms_pisces.F90
+   PUBLIC   p4z_lys_init    ! called in trcsms_pisces.F90
 
    !! * Shared module variables
@@ -42,7 +43,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -65,5 +66,5 @@
       REAL(wp) ::   zomegaca, zexcess, zexcess0
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zco3
-#if defined key_trc_dia3d && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zcaldiss
@@ -72,9 +73,7 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nittrc000  )   CALL p4z_lys_init      ! Initialization (first time-step only)
-
       zco3(:,:,:) = 0.
 
-# if defined key_trc_dia3d && defined key_iomput
+# if defined key_diatrc && defined key_iomput
       zcaldiss(:,:,:) = 0.
 # endif
@@ -146,5 +145,5 @@
                !       (ACCORDING TO THIS FORMULATION ALSO SOME PARTICULATE
                !       CACO3 GETS DISSOLVED EVEN IN THE CASE OF OVERSATURATION)
-# if defined key_off_degrad
+# if defined key_degrad
               zdispot = kdca * zexcess * trn(ji,jj,jk,jpcal) * facvol(ji,jj,jk)
 # else
@@ -160,5 +159,5 @@
               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +      zremco3
 
-# if defined key_trc_dia3d && defined key_iomput
+# if defined key_diatrc && defined key_iomput
               zcaldiss(ji,jj,jk) = zremco3  ! calcite dissolution
 # endif
@@ -167,5 +166,5 @@
       END DO
 
-# if defined key_trc_diaadd &&  defined key_trc_dia3d
+# if defined key_diatrc
 #  if ! defined key_iomput
       trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
@@ -197,5 +196,5 @@
       !!
       !! ** Method  :   Read the nampiscal namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep (nit000)
       !!
       !! ** input   :   Namelist nampiscal
